VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "myBug"
   ClientHeight    =   4875
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5400
   Icon            =   "myMain.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   4875
   ScaleWidth      =   5400
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdUpdate 
      Caption         =   "Update with .Update"
      Height          =   495
      Index           =   0
      Left            =   3000
      TabIndex        =   5
      Top             =   120
      Width           =   1215
   End
   Begin VB.ListBox List1 
      Height          =   3180
      Left            =   120
      TabIndex        =   4
      Top             =   1440
      Width           =   5055
   End
   Begin VB.CommandButton cmdClose 
      Caption         =   "Disconnect"
      Height          =   495
      Left            =   120
      TabIndex        =   3
      Top             =   720
      Width           =   1215
   End
   Begin VB.CommandButton cmdUpdate 
      Caption         =   "Update with .Execute"
      Height          =   495
      Index           =   1
      Left            =   3000
      TabIndex        =   2
      Top             =   720
      Width           =   1215
   End
   Begin VB.CommandButton cmdCreate 
      Caption         =   "Create database"
      Height          =   495
      Left            =   1560
      TabIndex        =   1
      Top             =   120
      Width           =   1215
   End
   Begin VB.CommandButton cmdConnect 
      Caption         =   "Connect"
      Height          =   495
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1215
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim tmpConnection As New ADODB.Connection
Dim queryS As String
Dim queryRS As New ADODB.Recordset

Private Sub cmdConnect_Click()
   With tmpConnection
      .ConnectionString = "DATA SOURCE=myGLK;"
      .ConnectionString = .ConnectionString & "USER ID=glk;"
      .ConnectionString = .ConnectionString & "PASSWORD=1883;"
      .ConnectionString = .ConnectionString & "OPTION=3;"
      .Open
   End With
   cmdConnect.Enabled = False
   cmdCreate.Enabled = True
   cmdUpdate(0).Enabled = False
   cmdUpdate(1).Enabled = False
   cmdClose.Enabled = False
   List1.AddItem "Connected"
End Sub

Private Sub cmdCreate_Click()
   On Error Resume Next
   queryS = "DROP DATABASE `test`;"
   Set queryRS = tmpConnection.Execute(queryS)
   On Error GoTo 0
   On Error Resume Next
   queryS = "CREATE DATABASE `test` /*!40100 DEFAULT CHARACTER SET latin1 */"
   Set queryRS = tmpConnection.Execute(queryS)
   On Error GoTo 0
   queryS = "USE `test`;"
   Set queryRS = tmpConnection.Execute(queryS)
   queryS = "CREATE TABLE `test` ("
   queryS = queryS & "`Id` smallint(6) NOT NULL default '0', "
   queryS = queryS & "`Counter` int(11) NOT NULL default '0', "
   queryS = queryS & "PRIMARY KEY (`Id`)) ENGINE=InnoDB DEFAULT CHARSET=latin1;"
   Set queryRS = tmpConnection.Execute(queryS)
   queryS = "INSERT INTO `test` (`Id`,`Counter`) Values (1,3), (2,3), (3,0), (4,3), (5,3);"
   Set queryRS = tmpConnection.Execute(queryS)
   cmdConnect.Enabled = False
   cmdCreate.Enabled = False
   cmdUpdate(0).Enabled = True
   cmdUpdate(1).Enabled = True
   cmdClose.Enabled = True
   List1.AddItem "Created database/table, added 5 entries"
   queryS = "SELECT Counter FROM TEST WHERE Id = 1"
   Set queryRS = tmpConnection.Execute(queryS)
   List1.AddItem "Id=1, Counter=" & CStr(queryRS!Counter)
   queryS = "SELECT Counter FROM TEST WHERE Id = 2"
   Set queryRS = tmpConnection.Execute(queryS)
   List1.AddItem "Id=2, Counter=" & CStr(queryRS!Counter)
   queryS = "SELECT Counter FROM TEST WHERE Id = 3"
   Set queryRS = tmpConnection.Execute(queryS)
   List1.AddItem "Id=3, Counter=" & CStr(queryRS!Counter)
   queryS = "SELECT Counter FROM TEST WHERE Id = 4"
   Set queryRS = tmpConnection.Execute(queryS)
   List1.AddItem "Id=4, Counter=" & CStr(queryRS!Counter)
   queryS = "SELECT Counter FROM TEST WHERE Id = 5"
   Set queryRS = tmpConnection.Execute(queryS)
   List1.AddItem "Id=5, Counter=" & CStr(queryRS!Counter)
   List1.AddItem " "
   List1.ListIndex = List1.NewIndex
End Sub


Private Sub cmdUpdate_Click(Index As Integer)
   List1.AddItem "Updating Counter for Id = 3 "
   If Index = 0 Then
      ' TEST 1 - this doesn't work
      queryS = "SELECT Counter FROM TEST WHERE Id = 3"
      Set queryRS = New ADODB.Recordset
      With queryRS
        .Open queryS, tmpConnection, adOpenStatic, adLockOptimistic
        !Counter = !Counter + 1
        .Update
        .Close
      End With
   Else
      ' TEST 2 - this works
      queryS = "UPDATE TEST Set Counter = Counter + 1  WHERE Id = 3"
      Set queryRS = tmpConnection.Execute(queryS)
   End If
   '
   queryS = "SELECT Counter FROM TEST WHERE Id = 1"
   Set queryRS = tmpConnection.Execute(queryS)
   List1.AddItem "Id=1, Counter=" & CStr(queryRS!Counter)
   queryS = "SELECT Counter FROM TEST WHERE Id = 2"
   Set queryRS = tmpConnection.Execute(queryS)
   List1.AddItem "Id=2, Counter=" & CStr(queryRS!Counter)
   queryS = "SELECT Counter FROM TEST WHERE Id = 3"
   Set queryRS = tmpConnection.Execute(queryS)
   List1.AddItem "Id=3, Counter=" & CStr(queryRS!Counter)
   queryS = "SELECT Counter FROM TEST WHERE Id = 4"
   Set queryRS = tmpConnection.Execute(queryS)
   List1.AddItem "Id=4, Counter=" & CStr(queryRS!Counter)
   queryS = "SELECT Counter FROM TEST WHERE Id = 5"
   Set queryRS = tmpConnection.Execute(queryS)
   List1.AddItem "Id=5, Counter=" & CStr(queryRS!Counter)
   List1.AddItem " "
   List1.ListIndex = List1.NewIndex
End Sub

Private Sub cmdClose_Click()
   With tmpConnection
      .Close
   End With
   cmdConnect.Enabled = True
   cmdCreate.Enabled = False
   cmdUpdate(0).Enabled = False
   cmdUpdate(1).Enabled = False
   cmdClose.Enabled = False
End Sub

' *************************************************************
Private Sub Form_Load()
   cmdConnect.Enabled = True
   cmdCreate.Enabled = False
   cmdUpdate(0).Enabled = False
   cmdUpdate(1).Enabled = False
   cmdClose.Enabled = False
End Sub ' *** Form_Load

Private Sub Form_Unload(Cancel As Integer)
   Set queryRS = Nothing
   Set tmpConnection = Nothing
   End
End Sub
